﻿using System;
using System.Web.Mvc;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.MvcEdition;

namespace DisplayASimpleMap.Controllers
{
    public class DisplayASimpleMapController : Controller
    {
        public ActionResult DisplayASimpleMap()
        {
            Map map = new Map("Map1",
                 new System.Web.UI.WebControls.Unit(100, System.Web.UI.WebControls.UnitType.Percentage),
                 new System.Web.UI.WebControls.Unit(100, System.Web.UI.WebControls.UnitType.Percentage));

            map.MapUnit = GeographyUnit.DecimalDegree;
            map.CurrentExtent = new RectangleShape(-125, 72, 50, -46);

            map.MapBackground = new BackgroundLayer(new GeoSolidBrush(GeoColor.FromHtml("#E5E3DF")));
            map.CustomOverlays.Add(new WorldMapKitWmsWebOverlay());

            WorldMapKitWmsWebOverlay worldMapKitOverlay = new WorldMapKitWmsWebOverlay("WorldMapKitOverlay");
            map.CustomOverlays.Add(worldMapKitOverlay);
            map.CustomOverlays.Add(new SimpleMarkerOverlay("markerOverlay") { OnClientClick = "clickOnMarker" });

            return View(map);
        }

        [MapActionFilter]
        public string ClickEvent(Map map, GeoCollection<object> args)
        {
            PointShape position = new PointShape(Convert.ToDouble(args[0]), Convert.ToDouble(args[1]));
            string Content = args[2].ToString();

            WebImage wimage = new WebImage(Url.Content("~/content/images/marker_blue.gif"));
            wimage.ImageOffsetY = -30;
            wimage.ImageOffsetX = -10;

            SimpleMarkerOverlay markerOverlay = map.CustomOverlays["markerOverlay"] as SimpleMarkerOverlay;

            Marker mrk = new Marker(position, wimage);
            mrk.IsVisible = true;

            markerOverlay.Markers.Clear();
            markerOverlay.Markers.Add(mrk);

            CloudPopup popup = null;
            popup = new CloudPopup("Popup", position, "This is a test pop up", 120, 80, true, true);
            popup.IsVisible = true;
            return popup.ToJson();
        }
    }
}